unit ffSetSQL;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ADOdb;

type
  TffSetSQL = class(TComponent)
  private
    { Private declarations }
     fADOQuery : TADOQuery;
     fSQLFilterStr : String;
     fSQLSortFields : String;
     fDisableSQLControls: Boolean;
     fAutoRequery : Boolean;
     fSortAscending : Boolean;


    Function  WhereIsStringInStrings(findStr: String): Integer;
    Procedure ChangeSQLClause(Const opt, SQLStr: String);
    Procedure RemoveSQLClause(Const sqlClause:String);
    Procedure SQLDoSortFields ;
    Procedure SQLDoFilter ;
    Procedure GetSQLFilter;
 // attempts to get the SQL ORDER BY String
     Procedure GetSQLSortOrder;

  protected
    { Protected declarations }
  public
    { Public declarations }
    Constructor Create(Aowner:TComponent); Override;
    Procedure Refresh ;



    Destructor Destroy; Override;
  published
    { Published declarations }
     Property ADOQuery : TADOQuery Read fADOQuery Write fADOQuery;
     Property SQLFilter : String Read fSQLFilterStr Write fSQLFilterStr ;
     Property SQLSortBy :  String Read fSQLSortFields Write fSQLSortFields;
     property AutoRequery : Boolean Read fAutoRequery Write fAutoRequery;
     property SortAscending : Boolean Read fSortAscending Write fSortAscending;
     property DisableSQLCtrls :  Boolean Read fDisableSQLControls Write fDisableSQLControls;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('ADO', [TffSetSQL]);
end;




Constructor TffSetSQL.Create(Aowner:TComponent);

begin

     inherited Create(Aowner);
     fAutoRequery := true;
     fSortAscending := True;




end;

destructor TffSetSQL.Destroy;

begin
     inherited Destroy;

end;

 // attempts to get the SQL WHERE String
Procedure TffSetSQL.GetSQLFilter;
var x : Integer;
begin


     x := WhereIsStringInStrings ('WHERE ');
     if x >= 0 then  fSQLFilterStr := fADOQuery.SQL[x];


end;

 // attempts to get the SQL ORDER BY String
Procedure TffSetSQL.GetSQLSortOrder;
var x : Integer;
begin

     x := WhereIsStringInStrings ('ORDER BY ');
     if x >= 0 then  fSQLSortFields  := fADOQuery.SQL[x];


end;


Procedure TffSetSQL.Refresh ;
var r : Boolean;

begin
      r := fAutoRequery ;
      fAutoRequery := false;


      if fDisableSQLControls then
         fADOQuery.DisableControls ;
         fADOQuery.close;

       if length(fSQLSortFields) >0 then
                 SQLDoSortFields
           else
                 RemoveSQLClause ('ORDER BY');

       if length(fSQLFilterStr ) > 0 then
           SQLDoFilter
           else
            RemoveSQLClause ('WHERE ');



     try
     fAutoRequery := r;



     if fAUtoRequery  then  ADOQuery.Open;
     Except
       MessageDlg('There was a problem processing '+#13+#10+
        'SQLFilter: '+#13+#10+'' +
        SQLFilter +#13+#10+'SQLSort:' +
        SQLSortBy , mtError, [mbOK], 0);
     end;

     GetSQLFilter ;
     GetSQLSortOrder ;


     ADOQuery.EnableControls ;


end;


Function TffSetSQL.WhereIsStringInStrings(findStr: String): Integer;
 var i : Integer;
begin
      // find the occurrence of a string in a string list
      i := 0;
      Result := -1;
      with fADOQuery do begin
      repeat
       if pos(UpperCase(findStr),UpperCase(SQL[i])) > 0 then
         result := i;
         inc(i);
       until  (i >= SQL.count) or (Result >=0);
      end;

end;

Procedure TffSetSQL.ChangeSQLClause(Const opt, SQLStr: String);

var i, w, o, x : Integer;
     s : String;
begin
      x := 0;
      w := x;
      o := x;
      s := '';

                  // remove trailing ;
             x := WhereIsStringInStrings (';');
             if x > 0 then
               begin
               s := fADOQuery.SQL[x];
               fADOQuery.SQL[x] := Copy(s,1,length(s)-1);
               end;

              // get index of WHERE and ORDER BY Clauses
              w := WhereIsStringInStrings ('WHERE ');
              o := WhereIsStringInStrings ('ORDER BY');



      if (COmpareText(trim(opt) + ' ' ,'WHERE ') = 0) then
          if w > 0 then
            fADOQuery.SQL[w] := sqlStr
          else
              if (o > 0) then
                  fADOQuery.SQL.insert(o,sqlstr)
              else
                  fADOQuery.SQL.Append (sqlStr);

      if (CompareText(trim(opt) + ' ','ORDER BY ') = 0) then
           if o > 0 then
              fADOQuery.SQL[o] := sqlStr
           else
              fADOQuery.SQL.Append(sqlStr);



end;


Procedure TffSetSQL.RemoveSQLClause(Const sqlClause:String);
var x : INteger;

begin

          if fDisableSQLControls then
              fADOQuery.DisableControls;

              fADOQuery.close;
              x := WhereIsStringInStrings (sqlClause);
              if x > 0 then fADOQuery.SQL.Delete (x);

              try
              if fAUtoRequery then fADOQuery.Open;
              Except

              end;
              fADOQuery.EnableControls ;
end;




Procedure TffSetSQL.SQLDoSortFields ;
var Sorder: String;
begin


        if fSortAscending then
                sOrder := ' ASC'
            else
                sOrder := ' DESC';

            if (pos('ORDER BY',uppercase(fSQLSortFields )) > 0) then
                ChangeSQLClause ('ORDER BY',fSQLSortFields + sOrder )
             else
                   ChangeSQLClause ('ORDER BY','ORDER BY ' + fSQLSortFields + sOrder);

end;


Procedure TffSetSQL.SQLDoFilter ;
begin
           if (pos('WHERE ',uppercase(fSQLFilterStr )) > 0) then
                ChangeSQLClause ('WHERE ',fSQLFilterStr)
             else
                   ChangeSQLClause ('WHERE ','WHERE ' + fSQLFilterStr);


end;

end.
